Test Interrupts in Simulide
----------------------------

This is for checking the timing of interrupts by running a ATtiny85
assembler program in Simulide. It uses the TIMER0 OVF interrupt to
measure the clock cycles an interrupt takes until the first instruction
in the ISR is executed.

The ISR reads the counter value and outputs it on port B. Since it
takes some time to execute the ISR the count will have moved forward
since the overflow occured. Hence, the counter will contain the cycles
used to execute the ISR.

According to the AVR documentation the interrupt execution response time
is 4 cycles for saving the PC on the stack. Afterwards the instruction
in the interupt vector table will be executed. This is usually a rjmp
instruction which takes another 2 cycles. So, the first instruction in
the ISR is executed 6 cycles after the timer overflow. The vector table
may as well contain the ISR code instead of a rjmp. That will probably
overwrite vectors of other interrupts (because there are just two bytes
for each vector), but this does not matter if no other interrupt is used.
Placing the ISR code right in the vector table saves 2 cycles (the rjmp).
There is a define in the asm file called `with_rjmp` to switch between
the two variants.

Simulide (Rev. 2188) just counts 4 cycles (even with rjmp), because the
interrupt execution response time is only 2 cycles long, which is most
likely a bug. It should be 4 cycles. I wonder why the instruction to
copy the timer value into the cnt register doesn't take another cycle.
Maybe another bug.
