.include "tn85def.inc"

.define with_rjmp 0

.define XTAL    1000000

.def    temp0 = r20
.def    temp1 = r21
.def    temp2 = r22
.def    temp3 = r23
.def    temp4 = r24
.def    cnt = r25           ;for storing TCNT0

.dseg   0x00

.cseg
.org 0x00
					rjmp RESET        ;jump into main routine

.org OVF0addr
.if with_rjmp == 1
					rjmp TIMER0_OVF   ;jump into timer0 overflow isr
.else
					in cnt,TCNT0      ;place timer0 overflow isr right here
					reti
.endif

.org 0x40
RESET:
					ldi temp1,0xff      ;put stack at 0x00ff in ram
					out SPL,temp1
					ldi temp1,0x01
					out SPH,temp1
					ldi temp1,0x1f      ;set port b to output
					out DDRB,temp1

					in temp1,TCCR0B     ;turn on clock without prescaling
					ori temp1,(1<<CS00)
					out TCCR0B,temp1
					in temp1,TIMSK      ;turn on timer0 overflow interrupt
					ori temp1,(1<<TOIE0)
					out TIMSK,temp1
					clr cnt             ;clear cnt register
					sei                 ;turn interrupts on
LOOP:
					nop
					nop
					out PORTB,cnt
					rjmp LOOP

TIMER0_OVF:
					;nop
					in cnt,TCNT0
					reti
